#ifndef __patchbmp_Patcher_h__
#define __patchbmp_Patcher_h__



#include <string>

#include "TileMap.h"
#include "ScriptReader.h"


class Patcher
{
public:
   typedef std::string string;

   Patcher();

   int runScript(const string& sFileName);


protected:
   ScriptReader mScr;

   struct Bitmap
   {
      TileMap tm;
      TileSpecs ts;
      
      Bitmap(const string& sName) : tm(sName) {}
      void setSpecs() {tm.setTileSpecs(ts);}
   };
   Bitmap mBase, mPatch;
   Bitmap& bitmap(const string& sWhich);
   
   typedef void (Patcher::*PCommand)(const string&);
   void load(const string& sWhich);
   void save(const string&);
   void tileSize(const string&);
   void tileSpecs(const string& sWhich);
   void merge(const string& sWhat);

   struct Vocab
   {
      const char* szVerb;
      const char* szObj;
      PCommand pmfnCmd;
   };
   static const Vocab mVocab[];
   static const int mnVocab;
};



#endif

