#include <stdio.h>
#include <ctype.h>
#include <stdarg.h>
#include <string>

#include "common.h"
#include "ScriptReader.h"



ScriptReader::ScriptReader()
   :
   mfp(NULL),
   mlLineNo(0)
   {
   }


ScriptReader::~ScriptReader()
   {
   close();
   }
   
   
void ScriptReader::open(const string& sFileName)
   {
   close();
   mfp = fopen(sFileName.c_str(), "rt");
   if (!mfp)
      throw Exception("Error opening file.");
   }


void ScriptReader::close()
   {
   if (mfp)
      {
      fclose(mfp);
      mfp = NULL;
      mlLineNo = 0;
      msLine.erase();
      msRest.erase();
      }
   }


bool ScriptReader::getLine()
   {
   static const size_t L = 1024;
   char szLine[L+1];

   do
      {
      if (!fgets(szLine, L, mfp))
         return false; 
      
      ++mlLineNo;
      msLine = szLine;
      msRest = msLine;
      
      size_t p;
      p = msRest.find("//");
      if (p != string::npos)
         {msRest.erase(p);}
      p = msRest.find_last_not_of(" \t\r\n");
      if (p == string::npos)
         {msRest.erase();}
      else
         {
         msRest.erase(p+1);
         p = msRest.find_first_not_of(" \t");
         msRest.erase(0, p);
         }
      } while (msRest.empty());
      
   return true;
   }


std::string ScriptReader::readWord(bool lower)
   {
   string sWord;
   
   size_t p = msRest.find_first_of(" \t");
   sWord = msRest.substr(0, p);
   msRest.erase(0, p);

   if (p != string::npos)
      {
      p = msRest.find_first_not_of(" \t");
      msRest.erase(0, p);
      }

   if (lower)
      {
      for (string::iterator itr = sWord.begin(); itr != sWord.end(); ++itr)
         {*itr = tolower(*itr);}
      }
   
   return sWord;
   }

