#ifndef __patchbmp_ScriptReader_h__
#define __patchbmp_ScriptReader_h__



#include <stdio.h>
#include <string>


class ScriptReader
{
public:
   typedef std::string string;
   
   ScriptReader();
   ~ScriptReader();
   
   bool opened() const {return (mfp != NULL);}
   void open(const string& sFileName);
   void close();

   bool getLine();
   long lineNo() const {return mlLineNo;}
   const string& line() const {return msLine;}

   const string& rest() const {return msRest;}
   string readWord(bool lower = true);
   

protected:
   FILE* mfp;
   long mlLineNo;
   string msLine, msRest;

private:
   ScriptReader(const ScriptReader&);
   ScriptReader& operator = (const ScriptReader&);
};



#endif

